# This file was generated by the `rspec --init` command. Conventionally, all
# specs live under a `spec` directory, which RSpec adds to the `$LOAD_PATH`.
# Require this file using `require "spec_helper"` to ensure that it is only
# loaded once.
#
# See http://rubydoc.info/gems/rspec-core/RSpec/Core/Configuration

lib = File.expand_path('../../lib', __FILE__)
$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)

$options = {}
$options[:env] = "test"
$options[:config] = File.expand_path("../files/config.yml", __FILE__)

require 'shared_spec'

def reset_nginx_conf
  File.open(File.expand_path("../files/nginx.conf", __FILE__), "w") do |f|
    f.write <<-END
      upstream unicorn {
        server 127.0.0.1:8001;
      }

      upstream phantomjs {
        server 127.0.0.1:8012;
        server 127.0.0.1:8013;
        server 127.0.0.1:8002;
        server 127.0.0.1:8003;
        server 127.0.0.1:8004;
        server 127.0.0.1:8005;
        server 127.0.0.1:8006;
        server 127.0.0.1:8007;
        server 127.0.0.1:8008;
        server 127.0.0.1:8009;
        server 127.0.0.1:8010;
        server 127.0.0.1:8011;
      }

      server {
        server_name _;

        location / {
          proxy_pass http://phantomjs;
        }
        blah
        bli
        omo
      }
    END
  end
end

RSpec.configure do |config|
  config.treat_symbols_as_metadata_keys_with_true_values = true
  config.run_all_when_everything_filtered = true
  #config.filter_run :focus

  # Run specs in random order to surface order dependencies. If you find an
  # order dependency and want to debug it, you can fix the order by providing
  # the seed, which is printed after each run.
  #     --seed 1234
  config.order = 'random'

  require 'utils/shell'
  config.before(:each)  { Utils::Shell.stub(:system) }

  config.before(:suite) { reset_nginx_conf }
  config.after(:suite) { reset_nginx_conf }
end
